
import './xcurrency.dart';
import './xdialling.dart';
import './xgeographical.dart';

import './xname.dart';
import './xvat_rate.dart';

import './xlanguage.dart';
import './xextra.dart';
import './xpopulation.dart';
import './xstate.dart';



class XCountry {
  String iso_3166_1_alpha2; //cca2
  String iso_3166_1_alpha3; //cca3
  String iso_3166_1_numeric; //ccn3
  final XName name;
  final Map<XLanguage, XName>? natives;
  final Map<XLanguage, XName>? translations;
  final List<String>? alt_spellings;

  List<String>? tld;

  String? cioc; //code International Olympic Committee (cioc)
  String? status;
  bool unMember;
  List<XCurrency>? currencies;
  XDialling? dialling;
  List<String>? capital;
  XGeographical? geographical;
  String? flag_symbol;
  List<XLanguage>? languages;
  XPopulation? population;
  XExtra? extra;
  List<XState?>? states;
  XVATrate? vat_rates;
  XCountry({
    required this.iso_3166_1_alpha2,
    required this.iso_3166_1_alpha3,
    required this.iso_3166_1_numeric,
    required this.name,
    this.natives,
    this.translations,
    this.alt_spellings,
    this.cioc,
    this.status,
    this.capital,
    this.tld,
    this.unMember = false,
    this.currencies,
    this.dialling,
    this.geographical,
    this.flag_symbol,
    this.languages,
    this.population,
    this.extra,
    this.states,
    this.vat_rates,
  });

  Map toJson() => {
        "iso_3166_1_alpha2": iso_3166_1_alpha2,
        "iso_3166_1_alpha3": iso_3166_1_alpha3,
        "iso_3166_1_numeric": iso_3166_1_numeric,
        "name": name.toJson(),
        "alt_spellings": alt_spellings,
        "natives": natives?.map((key, value) => MapEntry(key.iso_639_2__alpha3, value)),
        "translations": translations?.map((key, value) => MapEntry(key.iso_639_2__alpha3, value)),
        "flag_symbol": flag_symbol,
        "cioc": cioc,
        "status": status,
        "capital": capital,
        "tld": tld,
        "unMember": unMember,
        "currencies": List<String>.from(currencies!.map((e) => e.iso_4217_code)),
        "dialling": dialling?.toJson(),
        "geographical": geographical?.toJson(),
        "languages": List<String>.from(languages!.map((e) => e.iso_639_2__alpha3)),
        "population": population?.toJson(),
        "extra": extra?.toJson(),
        "states": states,
      };



  
}